from ngsolve.TensorProductTools import *
from ngsolve import *
from netgen.geom2d import unit_square
import netgen.gui
from math import pi
#%gui tk

meshx = Mesh(unit_square.GenerateMesh(maxh=0.25))
mesht = Mesh(SegMesh(5,0,1,periodic=True) )
tpmesh = Mesh(MakeTensorProductMesh(mesht,meshx)) 
Draw(tpmesh)

n=4
m=4

fesx = HDiv(meshx,order=n)
fest = H1(mesht,order=m)
tpfes = TensorProductFESpace([fest,fesx])
fesstd2 = L2(tpmesh,order = 4,dim=2)

u = GridFunction(tpfes)
# Set a grid function to (sin(2*pi*t) , cos(2*pi*z) ):
g = CoefficientFunction((ProlongateCoefficientFunction(sin(2*pi*x),1,tpfes),ProlongateCoefficientFunction(cos(2*pi*y),0,tpfes)))
# ProlongateCoefficicientFunction(coefficient, prolongateto,TensorProductFeSpace)
# coefficientfunction ... given in ngsolve syntax
# prolongateto ... prolongate "coefficientfunction" constantly to the space with number prolongateto, in other words, interpret coefficentfunction
#                  as a function in space (1-prolongateto).
# TensorProductFeSpace ... used for management purposes (a prolongatecoefficientfunction can be drawed directly, here we need to now the dimension of the component spaces, thus we have this third argument)


u.Set(g)
gstd2 = GridFunction(fesstd2)
Transfer2StdMesh(u,gstd2)
Draw(gstd2)
